#ifndef GROUP_H_
#define GROUP_H_

#include <iostream>
#include <vector>
#include <set>

#include "point.h"


using namespace std;

typedef class group *groupPtr;

class group{
public:	
	int numDimensions;
	int numMicroPoints;
	vector<point> points; // points inside group
	float** extent; // extent of group
	
	
	group(int numDimensions);
	group();
	group(const group &gp); // copy constructor
	~group();
	
	bool operator==(const group& gp) const;
	group& operator= (const group& gp);
	
	void insertPoint(point& po);
	float** getExtent();
	int getNumMicroPoints();
	float getPerimeter();
	float getNormalPerimeter(float* sizeWorld);

private:
	bool extentCalculated;
	bool numMicroPointsCalculated;
};


ostream& operator<<(ostream& os, const groupPtr &gp);

void calculateMetrics(vector<group> groups, float* sizeWorld);

#endif /*GROUP_H_*/
