#ifndef HILKANOM_H_
#define HILKANOM_H_

#include <fstream>
#include <sstream>
#include <string>
#include <vector>
#include <cfloat>

#include "../common/point.h"
#include "../common/group.h"
#include "../kdtree/kdtree.h"

using namespace std;

class HilKAnom{
public:
	KDTreePtr kdtree; // used to discover points for overlapping areas
	int numDimensions; // dimensionality
	vector<point> points;
	vector<group> groups; // K-anonymized groups
	int K; // anonymity requirement
	float* sizeWorld;
	
	HilKAnom(char* inputfile);
	~HilKAnom();
	
	float* getSizeWorld();
	
	vector<group> getGroups(int K);
	
private:
	bool groupsCalculated;
};


#endif /*HILKANOM_H_*/
