#include "hilScore.h"



HilScore::HilScore(float* p, float** extent, int dim, int b){
	this->b = b;
	this->dim = dim;
	axes = new coord_t[dim];
	line = new coord_t[dim];
	
	
	int scale = 1<<b;
//	cout << "scale=" << scale << endl;
	for (int d=0; d<dim; d++){
//		cout << "p[d]-extent[d][0] = " << (p[d]-extent[d][0]) << endl;
//		cout << "extent[d][1]-extent[d][0] = " << extent[d][1]-extent[d][0] << endl;
//		cout << "(p[d]-extent[d][0])/(extent[d][1]-extent[d][0] = " << (float)(p[d]-extent[d][0])/(extent[d][1]-extent[d][0]) << endl;
		float index = ((p[d]-extent[d][0])/(extent[d][1]-extent[d][0]))*scale;
//		cout << "index " << index << " " << endl;
		axes[d] = (int) index;		
	}
	
	AxestoLine(line, axes, b, dim);
}


HilScore::HilScore(const HilScore& sc){
	b = sc.b;
	dim = sc.dim; 
	axes = new coord_t[dim];
	line = new coord_t[dim];
	for (int d=0; d<dim; d++){
		axes[d] = sc.axes[d];
		line[d] = sc.line[d];
	}
}


HilScore::~HilScore(){
	delete[] axes;
	delete[] line;
}

ostream& operator<<(ostream& os, const HilScore& hil){
	os << "<" << hil.line[0];
	for (int d=1; d<hil.dim; d++){
		os << "," << hil.line[d];
	}
	os << ">";
	return os;
}


bool operator<(const HilScore& lhs, const HilScore& rhs){
	int cmp = CmpLabel(lhs.line, rhs.line, lhs.dim);
	if (cmp==-1) return true;
	return false;
}


bool operator==(const HilScore& lhs, const HilScore& rhs){
	int cmp = CmpLabel(lhs.line, rhs.line, lhs.dim);
	if (cmp==0) return true;
	return false;
}

/*
int main(int argc, char** argv){
	float p[3] = {100, 2, 200};
	
	float** extent = new float*[3];
	extent[0] = new float[2];
	extent[0][0] = 0;
	extent[0][1] = 200;
	extent[1] = new float[2];
	extent[1][0] = 0;
	extent[1][1] = 200;
	extent[2] = new float[2];
	extent[2][0] = 0;
	extent[2][1] = 200;
	
	HilScore* hil = new HilScore(p, extent, 3, 4);
	
	
}
*/
