#ifndef HILSCORE_H_
#define HILSCORE_H_

#include "hilbert.h"

class HilScore{
public:
	int dim; // dimensionality
	int b; // # bits per dimension
	coord_t* axes; // multidimensional geometrical axes   [dim]
	coord_t* line; // linear serial number, stored as     [dim]
	
	HilScore(float* p, float** extent, int dim, int b);
	HilScore(const HilScore& sc); // copy constructor
	~HilScore();
	
};

bool operator<(const HilScore& lhs, const HilScore& rhs);
bool operator==(const HilScore& lhs, const HilScore& rhs);

ostream& operator<<(ostream& os, const HilScore& hil);


#endif /*HILSCORE_H_*/
