#include "hilSort.h"

using namespace std;

int main(int argc, char **argv){
	
	if (argc!=3){
		cout << "Usage: " << argv[0] << " [inputFile] [bitsPerDimension]" << endl;
		exit(0);
	}
	
	int b = atoi(argv[2]);
	int dim;
	vector<float *> v;
	
	cout << "reading from " << argv[1] << endl;
	fstream fin(argv[1], ios::in);
	
	fin >> dim; // first read dimensionality
	while(!fin.eof()){
		float* p = new float[dim];
		for (int i=0; i<dim; i++){
			fin >> p[i];
		}
		v.push_back(p);
	}
	fin.close();
	cerr << "done reading " << v.size() << " points" << endl;
	
	// calculate extent
	float** extent = new float* [dim];
	cout << "extent : |";
	for (int d=0; d<dim; d++){
		vector<float> temp;
		for (uint i=0; i<v.size(); i++){
			temp.push_back(v[i][d]);
		}
		extent[d] = new float[2];
		extent[d][0] = *min_element(temp.begin(), temp.end()) - 1;
		extent[d][1] = *max_element(temp.begin(), temp.end()) + 1;
		cout << extent[d][0] << " -- " << extent[d][1] << "| ";
	}
	cout << endl;
	
	map<HilScore, float *> themap;
	
	for (uint i=0; i<v.size(); i++){
		HilScore *hil = new HilScore(v[i], extent, dim, b);
		themap.insert(pair<HilScore, float *>(*hil, v[i]));
	}
	
	cout << "there are " << themap.size() << " points in map" << endl;
	
	
	ostringstream fileout;
	fileout << "hs_" << argv[1] << "_p" << themap.size() ;
	ofstream fout;
	fout.open(fileout.str().c_str(), ofstream::out);
	
	fout << dim << endl;
	multimap<HilScore, float *>::iterator iter;
	
	for (iter=themap.begin(); iter!=themap.end(); iter++){
		if (iter==themap.begin()){
			fout << iter->second[0];
			for (int d=1; d<dim; d++){
				fout << " " << iter->second[d];
			}
		}
		else{
			fout << endl << iter->second[0];
			for (int d=1; d<dim; d++){
				fout << " " << iter->second[d];
			}
		}
	}
	fout.close();
	
//	for (iter=themap.begin(); iter!=themap.end(); iter++){
//		cout << iter->first << " :: ";
//		for (int d=0; d<dim; d++){
//			cout << iter->second[d] << " ";
//		}
//		cout << endl;
//	}
	
	
	
}
