#include "kdtree/kdtree.h"


using namespace std;


int main(int argc, char** argv){
	
	if (argc!=4) {
		cout << "Usage: " << argv[0] << " [microData] [publicData] [K]" << endl;
		cout << "K is anonymity requirement" << endl;
		exit(-1);
    }
	int K = atoi(argv[3]);
    int numDimensions;
    Timing* tim = new Timing();
    
    vector<pointPtr> publicPoints = readFromFile(argv[2], false, numDimensions);
    vector<pointPtr> microPoints = readFromFile(argv[1], true, numDimensions);
	
	tim->startClock();
	vector<pointPtr> joinedPoints = SortMerge(publicPoints, microPoints);
	long jointime = tim->stopClock();
	
//	cout << "there are " << joinedPoints.size() << " in join" << endl; 
//	int countMicro = 0;
//	for (uint i=0; i<joinedPoints.size(); i++){
////		cout << *(joinedPoints[i]) << endl;
//		if (joinedPoints[i]->inMicro ){
//			countMicro++;
//		}
//	}
//	cout << "there are " << countMicro << " from microData" << endl;
	
	cout << "MondrianDIR" << endl;
	tim->startClock();
	KDTreePtr tree = new KDTree(joinedPoints, K);
	long elapsed = tim->stopClock();
	
	tree->printMetrics();
	
	vector<group> groups = tree->getGroups();

	calculateMetrics(groups, tree->sizeWorld);
	cout << "Join Time: " << jointime << "  Elapsed Time: " << elapsed << endl;
	cout << "------------------------------------" << endl;
	cout << endl;
	
}

