#include "stripes/stripes.h"

#include <fstream>

using namespace std;

int main(int argc, char** argv){
	
	if (argc!=4) {
		cout << "Usage: " << argv[0] << " [microData] [publicData] [K]" << endl;
		cout << "K is anonymity requirement" << endl;
		exit(-1);
    }
	int K = atoi(argv[3]);
	int numDimensions;
	vector<pointPtr> points = readFromFile(argv[1], true, numDimensions);
	Timing* tim = new Timing();
	
    
    cout << "StripREF" << endl;
    tim->startClock();
    Stripes* str = new Stripes(points, K);
    long elapsed = tim->stopClock();
    
//    Stripes* str = new Stripes(argv[1], K);
//	MinPerTreePtr pub = new MinPerTree(argv[2], 2);
	KDTreePtr pub = new KDTree(argv[2], 2);
	cerr << "-------------------- trees built --------------------" << endl;
	
	
	tim->startClock();
	str->boostWithPublicData(str->root, pub);
	elapsed += tim->stopClock();
//	cout << "boosted" << endl;
	
	vector<group> groups = str->getGroups();
	calculateMetrics(groups, str->sizeWorld);
	groups.clear();
	cout << "Elapsed Time: " << elapsed << endl;
	cout << "------------------------------------" << endl;
	cout << endl;
	
}
