#include "tdtree/tdtree.h"


using namespace std;

int main(int argc, char** argv){
	
	if (argc!=4) {
		cout << "Usage: " << argv[0] << " [microData] [publicData] [K]" << endl;
		cout << "K is anonymity requirement" << endl;
		exit(-1);
    }
	int K = atoi(argv[3]);
    int numDimensions;
    Timing* tim = new Timing();
    
    vector<pointPtr> publicPoints = readFromFile(argv[2], false, numDimensions);
    vector<pointPtr> microPoints = readFromFile(argv[1], true, numDimensions);
	
	tim->startClock();
	vector<pointPtr> joinedPoints = SortMerge(publicPoints, microPoints);
	long jointime = tim->stopClock();
	
//	cout << "there are " << joinedPoints.size() << " in join" << endl; 
//	int countMicro = 0;
//	for (uint i=0; i<joinedPoints.size(); i++){
////		cout << *(joinedPoints[i]) << endl;
//		if (joinedPoints[i]->inMicro ){
//			countMicro++;
//		}
//	}
//	cout << "there are " << countMicro << " from microData" << endl;
	
	cout << "TopDownDIR" << endl;
	tim->startClock();
	TDTreePtr tree = new TDTree(joinedPoints, K);
	long splitTime = tim->stopClock();
	
	tim->startClock();
	tree->filter();
	long filterTime = tim->stopClock();
	
//	tree->printMetrics();
	
	vector<group> groups = tree->getGroups();
	
//	for (uint i=0; i<groups.size(); i++){
//		cout << &(groups[i]) << endl;
//	}
//	cout << endl;
	
//	cout << "I see " << groups.size() << " groups" << endl;
	calculateMetrics(groups, tree->sizeWorld);
	cout << "Join Time: " << jointime << " Split Time: " << splitTime << " Filter Time: " << filterTime << endl;
	cout << "------------------------------------" << endl;
	cout << endl;

	
}
